<%@page import="CheckoutData"%>
<%@page import="java.sql.*"%>
<%@page import="java.text.*"%>
<%@page import="java.util.*"%>


<%
	// Part 1: We retrieve and process all cookie
	// information right away so that our JSP will always
	// has this information on hand


	// Retrieve user and basket cookie data
	Cookie[] cookies = request.getCookies();
	String basketCookie = "", username = "", cid="";

	if(cookies!=null) {
		for (int i=0; i<cookies.length; i++) {
			Cookie singleCookie = cookies[i];
			if(singleCookie.getName().equals("basket"))
				basketCookie = singleCookie.getValue();
			if(singleCookie.getName().equals("username"))
				username = singleCookie.getValue();
			if(singleCookie.getName().equals("cid"))
				cid = singleCookie.getValue();
		}
	}
	boolean loggedIn = (!username.equals(""));

	
	// Convert the basket cookie data from a string to two arrays
	ArrayList items = new ArrayList(0);
	ArrayList qtys = new ArrayList(0);
	boolean basketEmpty = true;
	String tempWord="";
	char tempChar;

	// We reference elements in the basket cookie as:
	//   "ISBN1,Qty1:ISBN2,Qty2:ISBN3,Qty3: ... etc for however
	// many unique elements are in the cookie
	for(int i=0; i<basketCookie.length(); i++) {
		tempChar = basketCookie.charAt(i);
		if((tempChar==',')||(tempChar==':')) {
			if(tempChar==',')
				items.add(tempWord);
			else
				qtys.add(tempWord);
			tempWord="";
		}
		else
			tempWord += tempChar;
	}
	basketEmpty=(items.size()<1);
	boolean canCheckout=((loggedIn)&&(!basketEmpty));
%>


<HTML>
<TITLE>Step 1 - Verify Order</TITLE>
<BODY>
<script language="javascript" src="menu.js"></script>


<%
	// Part 2: If the user is logged in has at least one item
	// in their basket, we allow them to checkout and present
	// the form confirming their order

	boolean basketContainsValidItem = false;
	if(canCheckout) {
	
		// Display list of books ordered

		Class.forName("COM.ibm.db2.jdbc.app.DB2Driver");
		try {
	
			// We display each book's title and price
			// using information from the database
			Connection con = DriverManager.getConnection("jdbc:db2:bookshop","user","pass");
			Statement stmt = con.createStatement();
			double totalCost = 0;	
			NumberFormat n = NumberFormat.getCurrencyInstance(Locale.US);
			boolean first=false;

			for(int i=0; i<items.size();i++) {

				// Then, retrieve individual book information
				// from the database
				String sql = "SELECT isbn, title, price FROM Books WHERE ISBN = '"+items.get(i)+"'";
				ResultSet rs = stmt.executeQuery(sql);

				if(rs.next()) {

					// ***This code is only being generated if at least
					// one book is found in the database matching
					// a book in the user's shopping basket***


					// Update total cost of all books variable
					double cost = rs.getDouble("price")*Integer.parseInt((String)qtys.get(i));
					totalCost += cost;

					// On the first book found only, add some form header info
					if(!first) {
						first = true;
						basketContainsValidItem = true;
						out.println("<FORM NAME=\"Checkout\" ACTION=\"checkoutcont.jsp\" METHOD=\"POST\">");	
						out.println("<CENTER><TABLE WIDTH=\"80%\"><TR><TD><H2>Step 1 - Verify Order</H2></TD></TR></TABLE></CENTER>");
						out.println("<CENTER><TABLE WIDTH=\"65%\"><TR><TD>You are currently logged in as: <B>"+username+"</B></TD></TR></TABLE></CENTER><BR/>");
						out.println("<CENTER><IMG SRC=\"images\\line2.jpg\"><BR/></CENTER>");
						out.println("<CENTER><TABLE WIDTH=\"62%\"><BR/>");
					}

					// Finally, present this information to the user as a form
					out.println("<TR><TD><A HREF=\"bookhome.jsp?ISBN="+rs.getString("isbn")+"\">"+rs.getString("title")+"</A></TD>");
					out.println("<TD><B>"+qtys.get(i)+"</B></TD>");
					out.println("<TD><B> x </B></TD>");
					out.println("<TD ALIGN=\"RIGHT\">"+n.format(rs.getDouble("price"))+"</TD>");
					out.println("<TD> = </TD>");
					out.println("<TD ALIGN=\"RIGHT\"> "+n.format(cost)+" </TD>");
					out.println("</TR>");
				}
				rs.close();
			}
	
			// If at least one book was found, add closing HTML code
			if(basketContainsValidItem) {
				out.println("</TABLE>");
				out.println("<BR/><IMG SRC=\"images\\line2.jpg\"><BR/><BR/>");
				out.println("<TABLE WIDTH=\"62%\"><TR>");
				out.println("<TD WIDTH=\"15%\"></TD>");
				out.println("<TD WIDTH=\"10%\" ALIGN=\"RIGHT\"><B>Total:</B></TD>");
				out.println("<TD WIDTH=\"4%\" ALIGN=\"RIGHT\">"+n.format(totalCost)+"</TD>");
				out.println("</TR></TABLE></CENTER>");
				out.println("<INPUT TYPE=\"HIDDEN\" NAME=\"Cid\" VALUE=\""+cid+"\">");
				out.println("<INPUT TYPE=\"HIDDEN\" NAME=\"Username\" VALUE=\""+username+"\">");
				out.println("<INPUT TYPE=\"HIDDEN\" NAME=\"Basket\" VALUE=\""+basketCookie+"\">");
				out.println("<BR/><CENTER><TABLE WIDTH=\"80%\"><TR><TD>Please review the information above before proceeding.</TD></TR></TABLE></CENTER>");
				out.println("<CENTER><TABLE WIDTH=\"80%\"><TR><TD>If you would like to make any last minute changes, you may do so by editing your <A HREF=\"basket.jsp\">Shopping Basket</A></TD></TR></TABLE></CENTER><BR/>");
				out.println("<CENTER><INPUT TYPE=\"SUBMIT\" VALUE=\"Order Complete\"></CENTER>");
			}
	
			// We always close our database connection instances
			stmt.close();
			con.close();
		}
		catch(Exception e) {
			out.println(e.toString());
		}
	}


	// Part 3: If user is not ready to check out, we
	// tell them what they are missing

	basketEmpty = ((basketEmpty)||((canCheckout)&&(!basketContainsValidItem)));
	if(basketEmpty)
		out.println("<BR/><CENTER><TABLE WIDTH=\"65%\"><TR><TD>Your shopping cart is currently empty.  You must have at least one item in it in order to checkout.</TD></TR><BR/><BR/></TABLE></CENTER><BR/><BR/><BR/><BR/><BR/><BR/>");
	else if(!loggedIn) {
		out.println("<BR/><BR/><BR/><CENTER><TABLE WIDTH=\"65%\"><TR><TD>You are <B>not</B> currently logged in.</TD></TR>");
		out.println("<TR><TD>To checkout, please first select <A HREF=\"login.jsp\">login</A> go sign on.</TD></TR></TABLE></CENTER><BR/><BR/><BR/><BR/><BR/><BR/>");
	}
%>

</FORM>
</BODY>
<script language="javascript" src="footer.js"></script>
</HTML>