<%@page import="SearchData"%>
<%@page import="java.sql.*"%>
<%@page import="java.text.*"%>
<%@page import="java.util.*"%>


<jsp:useBean id="searchParams" class="SearchData">
	<jsp:setProperty name="searchParams"
	 property="searchType"
	 param="SearchType"/>

	<jsp:setProperty name="searchParams"
	 property="searchString"
	 param="SearchString"/>
</jsp:useBean>


<%!
	// Part 1: Setup JSP functions

	//
	// ReplaceQuote converts all single quotes to two single quotes.
	// Since single quotes are reserved characters in the database, 
      // we need this function in order to convert data that could
	// conceivably contain single quotes to an appropriate format
	// that the database will read.
	//
	public String replaceQuote(String input) {
		String temp="";
		for(int i=0; i<input.length(); i++)
			if(input.charAt(i)=='\'')
				temp += "''";
			else
				temp += input.charAt(i);
		return temp;
	}
%>


<HTML>
<TITLE>Search Results</TITLE>
<BODY>
<script language="javascript" src="menu.js"></script>
<CENTER><H1>Search Results</H1></CENTER>


<%
	// Part 2:  We first connect to the database and
	// see what books, if any, match our search criteria

 	Class.forName("COM.ibm.db2.jdbc.app.DB2Driver");
	try {
		Connection con = DriverManager.getConnection("jdbc:db2:bookshop","user","pass");
		Statement stmt = con.createStatement();
		String sql = "SELECT isbn, title, author, price FROM Books"
  			+" WHERE lower("+searchParams.getSearchTypeLabel()+")"
			+" like '%"+replaceQuote(searchParams.getSearchString()).toLowerCase().trim()+"%'"
			+" ORDER BY title";

		// Query Database using search modified search string
		ResultSet rs = stmt.executeQuery(sql);


		// Part 2:  We present all the books we've found
		// to the user

		NumberFormat n = NumberFormat.getCurrencyInstance(Locale.US);
		boolean first = true;
		while(rs.next()) {

			// On the first book found, we present header information
			// for the book list
			if(first) {
				first = false;
				out.println("<TABLE ALIGN = \"CENTER\" BORDER = \"4\" CELLPADDING = \"2\" WIDTH = \"75%\" bordercolor = \"darkblue\">");
				out.println("<TR>");
				out.println("<TH ALIGN=center>Title</TH>");
				out.println("<TH ALIGN=center>Author</TH>");
				out.println("<TH ALIGN=center>Price</TH>");
				out.println("</TR>");
			}
			out.println("<TR>");
			out.println("<TD ALIGN=\"LEFT\">");
			out.println("<A HREF=\"bookhome.jsp?ISBN="+rs.getString("isbn")+"\">");
			out.println(rs.getString("title")+"</A></TD>");
			out.println("<TD ALIGN=\"LEFT\">"+rs.getString("author")+"</TD>");
			out.println("<TD ALIGN=\"RIGHT\">"+n.format(rs.getDouble("price"))+"</TD>");
			out.println("</TR>");
  		}

		// first is true here if no books were found, so we inform
		// the user
		if(first) {
			out.println("<TABLE ALIGN = \"CENTER\" CELLPADDING = \"2\" WIDTH = \"75%\"</TR></TD><BR/><BR/>");
			out.println("Sorry, no books were found matching your search criteria");
			out.println("</TD></TR></TABLE><BR/><BR/><BR/><BR/><BR/><BR/>");
		}
		else
			out.println("</TABLE>");

		// We always close our database connection instances
		rs.close();
		stmt.close();
		con.close();

	} catch(Exception e) {
		out.println(e.toString());
	}   
%>

</BODY>
<script language="javascript" src="footer.js"></script>
</HTML>